#!/bin/bash
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
cd $DIR
cd engine
rm izsetup.jar
rm -rf lib
cp -r /etc/jnkns/workspace/iZSetup/dist/lib lib
cp /etc/jnkns/workspace/iZSetup/dist/IZSetup.jar izsetup.jar
cd ../
cd bundledata
cd ../

cd predist
cd ../
cd dist
rm izsetup.exe_bak
mv izsetup.exe izsetup.exe_bak
cd ../
cd engine
rar a -r -sfx -z"../sfxcomm.txt" engine.exe *
mv engine.exe ../bundledata/engine.exe
cd ../

cd demopackage
rar a -r -sfx -z"../distsfxcomm.txt" demopackage.exe *
mv demopackage.exe ../bundledata/demopackage.exe
cd ../

cd bundledata
7z a t.zip *
mv t.zip izsetup.izbundle
mv izsetup.izbundle ../predist/izsetup.izbundle
cd ../

cd predist
rar a -r -sfx -z"../distsfxcomm.txt" izsetup.exe *
mv izsetup.exe ../dist/izsetup64.exe
cd ../
cd dist
mkdir $1
cp izsetup64.exe $1/izsetup64.exe
cp izsetup64.exe ../../dist/izsetup64.exe
cd ../