/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.nplusc.izc.InstallPak;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;

/**
 *
 * @author LH
 */
public class InstallManager
{
    public static InstallManager Main;
    private String[] InstallQueue;
    private String[] Groups;
    private String[] enabledGroupIDs;
    private HashMap<String,ArrayList<String>> groupsplitted = new HashMap<>();
    static{
        Main=  new InstallManager();
      //  Main.setInstallScript(ModeSel.filePath);
    }
    
    public String[] getToggleAblePrograms()
    {
        Arrays.sort(Groups);
        return Groups;
    }
    
    public void setInstallScript(String path)
    {
        String[] data = izsetupReader.getSysSpezSetupFile(path);
        String groupID="000"; 
        String previousGRPID ="000";
        
        ArrayList<String> SubGroup = new ArrayList<>();
        for (String line : data)
        {
            if(!(line.length()<6))
            {
                String[] splittedLine = line.split("\\|");
                //DBG_START
               // System.err.println(splittedLine[0]+"|GRP");
               // System.err.println(splittedLine[1]+"|KEY");
               // System.err.println(splittedLine[2]+"|VAL");
               // System.err.println(splittedLine[3]+"|CMNT");
                //DBG_STOP
                if(!splittedLine[0].equals("000"))
                {
                    groupID=splittedLine[0];
                    if(!previousGRPID.equals(groupID)&&!previousGRPID.equals("000"))
                    {
                        groupsplitted.put(previousGRPID, SubGroup);//Einlagern der abgeschlossenen gruppe
                        SubGroup = new ArrayList<>();//resetten für neue daten;
                    }
                    SubGroup.add(line);
                    previousGRPID=groupID;

                }
            }
        }
        groupsplitted.put(previousGRPID, SubGroup);//die letzte auch noch einflanschen
        String[] groupIDs = groupsplitted.keySet().toArray(new String[0]);
        ArrayList<String> lenabledGroupIDs = new ArrayList<>();
        ArrayList<String> lGroups = new ArrayList<>();
        for (String id : groupIDs)
        {
            lenabledGroupIDs.add(id);
            
            if(groupsplitted.get(id).get(0).split("\\|")[1].equalsIgnoreCase("grp")||groupsplitted.get(id).get(0).split("\\|")[1].equalsIgnoreCase("group"))
            {
                String groupname = groupsplitted.get(id).get(0).split("\\|")[2];//angelt sich erste zeile der Gruppe davon 3. Wert
                                                                                //wenn nicht mit grp oder group eingeleitetdann immer ausgeführt
                lGroups.add(id+"|"+groupname);
            }
        }
        Groups = lGroups.toArray(new String[0]);
        enabledGroupIDs=lenabledGroupIDs.toArray(new String[0]);
    }
    public void setGroupState(String grpid,boolean state)
    {
        boolean exists = false;
        for (int i = 0; i < enabledGroupIDs.length; i++)
        {
            String id = enabledGroupIDs[i];
            if(grpid.equals(id))
            {
                exists=true;
                if(!state)
                {
                    enabledGroupIDs[i]="";
                }
            }
        }
        ArrayList<String> newGrps = new ArrayList<>();
        for (String cnt : enabledGroupIDs)
        {
            if(cnt.length()>1)
            {
                newGrps.add(cnt);
            }
        }
        if(!exists&&state)
        {
            newGrps.add(grpid);
        }
        enabledGroupIDs = newGrps.toArray(new String[0]);
    }
    public String[] getInstallQueue()
    {
        return InstallQueue;
    }
    
    
    public void createQueue()
    {
        ArrayList<String> TempQueue = new ArrayList<>();
        Arrays.sort(enabledGroupIDs);
        //System.err.println("nop");
        for (String id : enabledGroupIDs)
        {
            ArrayList<String> loadedGroup = groupsplitted.get(id);
            for (String lines : loadedGroup)
            {
                String[] linedata =lines.split("\\|");
                if(linedata[1].equalsIgnoreCase("msg")||linedata[1].equalsIgnoreCase("exec")||linedata[1].equalsIgnoreCase("requireExec"))
                {
                    TempQueue.add(linedata[2]);
                }
            }
        }
        InstallQueue = TempQueue.toArray(new String[0]);
    }
}
