/*
 * Copyright (C) 2014 iZc <nplusc.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package de.nplusc.izc.izstreamer;

import de.nplusc.izc.tools.UiToolz.HoloJPanel;
import de.nplusc.izc.tools.baseTools.Messagers;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.ByteBuffer;
import java.util.zip.CRC32;
import javax.imageio.ImageIO;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.WindowConstants;
import org.apache.commons.io.FileUtils;

/**
 *
 * @author LH
 */

public class VisualizedGUI extends JFrame implements PlayerStructure, ImageObserver
{
    private boolean eeggt=false;
    private boolean eeggd=false;
    private BufferedImage image;
    private final int x = iZstreamer.width;
    private final int y = iZstreamer.height;
    private Canvas surface;
    HoloJPanel drawer = new HoloJPanel();
    private VisualizedGUI thiz ;
            
   // @Override
           /* public void display(DirectMediaPlayer mediaPlayer, Memory[] nativeBuffer, BufferFormat bufferFormat)
            {
                BufferedImage i = surface.getImage();
                WritableRaster r = i.getRaster();
                int[] rgbbuffer = ((DataBufferInt) r.getDataBuffer()).getData();
                //code from VLCJs renderCallbackAdapter class
                ByteBuffer b = nativeBuffer[0].getByteBuffer(0L, nativeBuffer[0].size());
                int destBbS = bufferFormat.getHeight() * bufferFormat.getWidth();
                System.out.println(b.capacity()/4+"|"+destBbS);
                b.asIntBuffer().get(rgbbuffer, 0, destBbS);
                repaint();
            }*/

    @Override
    public void setPlaying(String titp)
    {
        tit.setText("Now playing: "+ titp);
    }

    @Override
    public void updateSender(String s)
    {
      //  throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    BufferedImage i2=null;
    MouseAdapter eegg = new MouseAdapter()
        {
            private int progress=0;
            private String urlin = "";
            private String dfile = "";
            @Override
            public void mouseClicked(MouseEvent e)
            {
                progress++;
                //
                eeggt=true;
                //Messagers.SingleLineMsg(String.format("%8h",temp.getValue()), "NOP");
                urlin+=iZstreamer.magic[e.getX()/7]+"|";
                System.out.println(urlin);
                if(progress>=13)
                {
                    eeggd=true;
                    CRC32 temp = new CRC32();
                    temp.update(urlin.getBytes());
                    long temp2=temp.getValue();
                    urlin= "http://nplusc.de/"+String.format("%8h", temp2)+".png";
                    dfile=iZstreamer.jpath+"\\"+String.format("%8h",  temp2)+".png";
                    System.out.println(dfile);
                    tit.removeMouseListener(eegg);//einweggag
                    System.out.println(urlin);
                    new Thread(() ->
                    {
                        try
                        {
                            
                            File f = new File(dfile);
                            FileUtils.copyURLToFile(new URL(urlin), f);
                            System.out.println("dled");
                            System.out.println(f.length());
                            if(f.length()>5000)
                            {
                                BufferedImage i = ImageIO.read(f);
                                System.out.println("loading");
                                 
                                BufferedImage surfy = new BufferedImage(x,y,BufferedImage.TYPE_4BYTE_ABGR);
                                /*
                                i = (BufferedImage) i.getScaledInstance(surface.getWidth(), -1, 0);
                                surfy.getGraphics().drawImage(i, 0, 0, thiz);
                                ready=false;
                                //while(!ready);
                                System.out.println("scaling1");
                                if(i.getHeight()>surface.getHeight())
                                {
                                    i = (BufferedImage) i2.getScaledInstance(-1, surface.getHeight(), 0);
                                    System.out.println("scaling2");
                                }
                                surfy.getGraphics().drawImage(i, 0, 0, thiz);
                                ready=false;
                               // while(!ready);
                               
                               */
                                Graphics g =surfy.getGraphics() ;
                                g.setColor(Color.black);
                                g.drawRect(0, 0, x, y);
                                g.fillRect(0, 0, x, y);
                                System.out.println("cleared");
                                g.drawImage(i, x, y, null);
                                Thread.sleep(1200);
                                System.out.println("ready");
                                remove(surface);
                                
                                drawer.setdrawIMG(i);
                                drawer.setSize(x,y);
                                drawer.setBounds(0,0,x, y);
                                add(drawer);
                                repaint();
                            }
                        }
                        catch (Exception ex)
                        {
                            ex.printStackTrace();
                            
                        }
                    }).start();
                }
            }
            
            
            
            
        };
    private JLabel tit;
    private JButton play,info,last20trax;
    private JSlider vol;
    private JSlider volume;
    private boolean playing;
    public VisualizedGUI()
    {
        thiz=this;
        /*
        
        surface= new EJP();
        image = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().
                getDefaultConfiguration().createCompatibleImage(x,y);
        surface.setSize(x, y);
        surface.setdrawIMG(image);
        setLayout(new GridLayout(1, 1));
       */
       // this.add(c);
        setLayout(null);
        surface = new Canvas();
        surface.setBounds(0,0,x, y);
        add(surface);
        setSize(x,y+200);
        tit=new JLabel("Now playing: Track name should be here"); //Now Playing: 
        
        
        
        
        //"No_w _p_layi_ng: T_r_ack nam_e_ s_hou_ld be here"
        
        //Optimus Prime
        tit.setBounds(0, y,x, 15);
        tit.addMouseListener(eegg);
        tit.setFont(new Font(Font.MONOSPACED, Font.PLAIN, 12));
        play = new JButton("Play");
        play.setBounds(0,y+15,300,80);
        info = new JButton("Info");
        info.setBounds(310,y+15,100,50);
        last20trax = new JButton("LastTrax");
        last20trax.setBounds(420,y+15,80,40);
        volume = new JSlider();
        volume.setBounds(0, y+90, x, 60);
        volume.setMinimum(0);
        volume.setMaximum(100);
        volume.setValue(100);
        volume.addMouseMotionListener(new MouseMotionAdapter()
        {

            @Override
            public void mouseDragged(MouseEvent e)
            {
                if(StreamGUI.player.m!=null)
                {
                StreamGUI.player.m.setVolume(volume.getValue());
                }
            }
        });
        add(volume);
        add(play);
        add(tit);
        add(info);
        add(last20trax);
        play.addActionListener((ActionEvent e) ->
        {
            if(eeggd)
                {remove(drawer);
                add(surface);
                }
            tit.setText("Now Playing:");
            tit.removeMouseListener(eegg);
            if (playing)
            {
                play.setText("PLAY");
                StreamGUI.player.stopPlay=true;
            }
            else
            {
                play.setText("STOP");
                StreamGUI.player.play();
            }
            playing = !playing;
            
        });
        info.addActionListener((ActionEvent e) ->
        {
            Messagers.SingleLineMsg("Not implemented", "Klappe halten.....");
        });
        
         last20trax.addActionListener((ActionEvent e) ->
        {
            try
            {
                Desktop.getDesktop().browse(new URI("http://31.7.177.108:2294/played.html"));
            }
            catch (URISyntaxException ex)
            {
                ex.printStackTrace();
            }
            catch (IOException ex)
            {
                ex.printStackTrace();
            }
        });
        
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        validate();
        StreamGUI.player.setPlayerStructure(this);
        setResizable(false);/*
        new Thread(() ->
        {
            try
            {
                while(!isVisible());
                
                
                Thread.sleep(1500);
            }
            catch (InterruptedException ex)
            {
                ex.printStackTrace();
            }
            if(!eeggt)
            {
                tit.setText("Now Playing:");
                tit.removeMouseListener(eegg);
            }
        }).start();*/
        // setSize(x, y);
    }

    @Override
    public Canvas getBackGround()
    {
        return surface;
    }
    
    
    /*
    private class EJP extends JPanel
{
        private BufferedImage image;
        
        private BufferedImage getImage()
        {
            return image;
        }

        public void setdrawIMG(BufferedImage image) {
            this.image = image;
        }

        @Override
        public void paint(Graphics g) 
            {
            Graphics2D g2 = (Graphics2D)g;
            g2.drawImage(image, null, 0, 0);
            // You could draw on top of the image here...
            }
        };
    */
    private boolean ready = false;
    
    @Override
    public boolean imageUpdate(final Image img, int infoflags, int x, int y,
            int width, int height) {

        boolean result = true;
        if((infoflags | ImageObserver.FRAMEBITS) == ImageObserver.FRAMEBITS){
            result = false;
        } else if((infoflags | ImageObserver.ALLBITS) == ImageObserver.ALLBITS){
            result = false;
        }

        if(result){
            System.out.println("Image incomplete");
        } else{
            System.out.println("Complete");
        }
        ready=result;
        return result;
    }
    
}
