/*
 * Copyright (C) 2014 iZc <nplusc.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package de.nplusc.izc.izstreamer;

import com.sun.awt.AWTUtilities;
import com.sun.jna.platform.WindowUtils;
import java.awt.Canvas;
import java.awt.Window;
import java.awt.event.ActionEvent;
import javax.swing.JButton;
import javax.swing.JFrame;

/**
 *
 * @author LH
 */
public class VisualizedGUIOverlay extends Window implements PlayerStructure
{
    private StreamGUI ctrl;
    private JButton p ;
    private static int x = iZstreamer.width;
    private static int y =iZstreamer.height;
    private boolean playing=true;//hack...
        
    public VisualizedGUIOverlay(StreamGUI s,JFrame owner)
    {
        super(owner,WindowUtils.getAlphaCompatibleGraphicsConfiguration());
        //setDefaultCloseOperation(EXIT_ON_CLOSE);;
        AWTUtilities.setWindowOpaque(this, false);
        setSize(x,y);
        ctrl=s;
        setLayout(null);
        p = new JButton("STOP");
        p.setSize(60, 25);
        
        p.setBounds(x-60, y-25, 60, 25);
        this.add(p);
        p.addActionListener((ActionEvent e) ->
        {
            if (playing)
            {
                p.setText("PLAY");
            }
            else
            {
                p.setText("STOP");
            }
            playing = !playing;
            ctrl.play();
        });
    }

    @Override
    public void setPlaying(String tit)
    {
        //throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void updateSender(String s)
    {
        //throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public Canvas getBackGround()
    {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
           
}
